<template>
  <v-container>
    <v-row>
      <v-col v-if="typeResults.length" cols="7" class="list-wrapper">
        <b>
          <v-checkbox
            v-model="isAllTypesChecked"
            on-icon="mdi-checkbox-blank-circle"
            off-icon="mdi-checkbox-blank-circle-outline"
            :color="$store.state.primaryColor"
            hide-details
            dense
            class="settings-bar-checkbox"
            :label="$t('generic.concept.types')"
            @click="all('type')"
          />
        </b>

        <div class="settings-bar-checkbox-wrapper overflow-y-auto">
          <template v-for="(type, index) in types">
            <v-checkbox
              :key="index"
              v-model="typeResults[index].v"
              class="settings-bar-checkbox"
              hide-details
              :label="typeResults[index].t"
              @click="updateTypes"
            />
          </template>
        </div>
      </v-col>

      <v-col class="align-center fill-height" cols="2">
        <b>Tags, Comments</b>
        <br>
        <v-text-field
          v-model="searchString"
          :label="$t('button.filter')"
          prepend-inner-icon="mdi-magnify"
          dense
          hide-details
          @input="handleSearchString"
        />
      </v-col>

      <v-col v-if="layerResults.length > 1" cols="3" class="list-wrapper">
        <b>
          <v-checkbox
            v-model="isAllLayersChecked"
            on-icon="mdi-checkbox-blank-circle"
            off-icon="mdi-checkbox-blank-circle-outline"
            :color="$store.state.primaryColor"
            hide-details
            dense
            class="settings-bar-checkbox"
            :label="$t('generic.concept.layers')"
            @click="all('layer')"
          />
        </b>
        <div class="settings-bar-checkbox-wrapper overflow-y-auto">
          <template v-for="(layer, index) in layers">
            <v-checkbox
              :key="index"
              v-model="layerResults[index].v"
              class="settings-bar-checkbox"
              hide-details
              :label="layerResults[index].t"
              @click="updateLayers"
            />
          </template>
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import type AnalysisActions from '@/logic/AnalysisActions';
import {
  Component, Prop, Vue, Watch,
} from 'vue-property-decorator';
import type { TypeFilter } from '@/logic/LabelFilters';
import { LabelFilterType } from '@/logic/LabelFilters';

@Component
export default class SettingsBar extends Vue {
  @Prop({ required: true })
  actions!: AnalysisActions;

  @Prop()
  types!: Array<string>;

  @Prop()
  layers!: Array<string>;

  typeResults: Array<{t: string, v: boolean}> = [];

  layerResults: Array<{t: string, v: boolean}> = [];

  isAllTypesChecked = true;

  isAllLayersChecked = true;

  searchString = '';

  mounted() {
    this.setTypes();
    this.setLayers();
  }

  handleSearchString() {
    this.actions.updateSearchString(this.searchString);
  }

  all(filterType: LabelFilterType) {
    if (filterType === LabelFilterType.Layer) {
      if (this.isAllLayersChecked) {
        this.layerResults = this.layerResults.map((l) => ({ ...l, v: true }));
      } else {
        this.layerResults = this.layerResults.map((l) => ({ ...l, v: false }));
      }
      this.updateLayers();
    } else if (filterType === LabelFilterType.Type) {
      if (this.isAllTypesChecked) {
        this.typeResults = this.typeResults.map((t) => ({ ...t, v: true }));
      } else {
        this.typeResults = this.typeResults.map((t) => ({ ...t, v: false }));
      }
      this.updateTypes();
    }
  }

  @Watch('types')
  setTypes() {
    if (this.typeResults.length === 0) {
      this.typeResults = [...new Set(this.types)].map((t) => ({ t, v: true }));
    } else {
      const newTypes: Array<{t: string, v: boolean}> = [];
      this.types.forEach((type) => {
        const founded = this.typeResults.find((t) => t.t === type);
        if (founded) {
          newTypes.push({
            t: founded.t,
            v: this.actions.getFilterValueFor(founded.t, LabelFilterType.Type),
          });
        } else {
          newTypes.push({
            t: type,
            v: true,
          });
        }
      });
      this.typeResults = [...newTypes];
    }
  }

  @Watch('layers')
  setLayers() {
    if (this.layerResults.length === 0) {
      this.layerResults = [...new Set(this.layers)].map((t) => ({ t, v: true }));
    } else {
      const newLayers: Array<{t: string, v: boolean}> = [];
      this.layers.forEach((layer) => {
        const founded = this.layerResults.find((t) => t.t === layer);
        if (founded) {
          newLayers.push({
            t: founded.t,
            v: this.actions.getFilterValueFor(founded.t, LabelFilterType.Layer),
          });
        } else {
          newLayers.push({
            t: layer,
            v: true,
          });
        }
      });
      this.layerResults = [...newLayers];
    }
  }

  // @Watch('typeResults', { deep: true })
  async updateTypes() {
    const filters: TypeFilter = {};
    this.types.forEach((t) => {
      if (this.typeResults.find((tr) => tr.t === t && tr.v)) {
        filters[t] = true;
      } else {
        filters[t] = false;
      }
    });
    this.actions.updateTypesFilter(filters);
    this.isAllTypesChecked = this.typeResults.filter((t) => t.v).length === this.types.length;
    await Vue.nextTick();
  }

  // @Watch('layerResults', { deep: true })
  async updateLayers() {
    const filters: TypeFilter = {};
    this.layers.forEach((t) => {
      if (this.layerResults.find((lr) => lr.t === t && lr.v)) {
        filters[t] = true;
      } else {
        filters[t] = false;
      }
    });
    this.actions.updateLayersFilter(filters);
    this.isAllLayersChecked = this.layerResults.filter((l) => l.v).length === this.layers.length;
    await Vue.nextTick();
  }
}
</script>

<style lang="scss" scoped>
.list-wrapper {
  border-right: 1px solid #00000033;
  border-left: 1px solid #00000033;
  padding: 8px 0 0 10px;
  color: var(--v-primary-base) !important;
}

.settings-bar-checkbox {
  margin: 0;
  padding-top: 4px;
  padding-bottom: 4px;
  flex-basis: 33.3%;
  width: 33.3%;
  min-width: 150px;
  text-overflow: ellipsis;

  &-wrapper {
    max-height: 150px;
    display: flex;
    flex-wrap: wrap;
    width: 100%;
  }

  &:hover {
    background-color: rgba(0, 0, 0, 0.1);
  }
}
</style>
